/*
	$Id: ToplevelCompoundImpl.java 309 2007-03-24 21:57:27Z syl $

	Copyright (C) 2006 Syllabub
	Maroontress Fast Software.
*/

package com.maroontress.sanctuary;

import org.w3c.dom.Element;
import java.io.PrintWriter;

/**
   ȥåץ٥륳ѥɤμǤ
*/
public abstract class ToplevelCompoundImpl extends CompoundImpl
    implements ToplevelCompound {

    /** ι¤Τޤ϶Τޤ󷿤̾ */
    private Strings as;

    /** ι¤Τޤ϶Τޤ󷿤Υ̾ */
    private Strings tag;

    /**
       ȥåץ٥륳ѥɤޤ

       @param g 饹
       @param label "struct" ޤ "union" ޤ "enum"
       @param elem structǤޤunionǤޤenum
       @param tag tag°
       @param as alias°͡typedef̾
    */
    protected ToplevelCompoundImpl(final Class g, final String label,
				   final Element elem, final Strings tag,
				   final Strings as) {
	super(g, label, elem,
	      ((!as.getFull().equals(""))
	       ? as
	       : Strings.prepend(label + " ", tag)));
	this.tag = tag;
	this.as = as;
    }

    public Strings getName() {
	return ((tag.getFull().equals(""))
		? tag : Strings.prepend(getLabel() + " ", tag));
    }

    /**
       {@inheritDoc}
    */
    @Override protected final Description getDescription(
	final ChildrenFilter c) {
	return new Description(c.getDirectChildrenByTagName("desc"));
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getSummaryName() {
	Group group = getGroup();
	String t = tag.getFull();
	String label = getLabel();

	if (as.getFull().equals("")) {
	    return super.getSummaryName();
	}
	return "<b>" + group.getHTML(as.getFull()) + "</b> ("
	    + group.getHTML(t.equals("") ? label : label + " " + t)
	    + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getDetailName() {
	String t = tag.getShorten();
	String label = getLabel();

	if (as.getFull().equals("")) {
	    return super.getDetailName();
	}
	if (t.equals("")) {
	    return "<b>" + as.getShorten() + "</b> (" + label + ")";
	}
	return "<a name=\"" + label + " " + tag + "\"></a>"
	    + "<b>" + as.getShorten() + "</b> (" + label + " " + t + ")";
    }

    /**
       {@inheritDoc}
    */
    @Override protected String getTexDetailName() {
	String t = tag.getShorten();
	String label = getLabel();

	if (as.getFull().equals("")) {
	    return super.getTexDetailName();
	}
	return as.getShorten() + " ("
	    + (t.equals("") ? label : label + " " + t)
	    + ")";
    }

    public void printCode(final PrintWriter wr) {
	String indent = "    ";
	String pre = "", post = "";
	String a = as.getFull();
	String t = tag.getFull();
	String label = getLabel();

	if (!a.equals("")) {
	    pre = "typedef " + label;
	    if (!t.equals("")) {
		pre += " " + t;
	    }
	    pre += " {";
	    post = "} " + a + ";";
	} else {
	    pre = label + " " + t + " {";
	    post = "};";
	}
	wr.println(pre);
	getComponents().printCode(wr, indent);
	wr.println(post);
    }
}
